PrefabFiles = {
	"wayrra",
	"orbstaff",
	"sanityorb",
	"orbstafffire",
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/wayrra.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/wayrra.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/wayrra.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/wayrra.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/wayrra_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/wayrra_silho.xml" ),

    Asset( "IMAGE", "bigportraits/wayrra.tex" ),
    Asset( "ATLAS", "bigportraits/wayrra.xml" ),
	
	Asset( "IMAGE", "images/map_icons/wayrra.tex" ),
	Asset( "ATLAS", "images/map_icons/wayrra.xml" ),
	
	Asset("ATLAS", "images/inventoryimages/sanityorb.xml"),
	Asset("IMAGE", "images/inventoryimages/sanityorb.tex"),
	
	Asset( "IMAGE", "images/map_icons/orbstaff.tex" ),
	Asset( "ATLAS", "images/map_icons/orbstaff.xml" ),
}

GetPlayer = GLOBAL.GetPlayer
GetWorld = GLOBAL.GetWorld
ACTIONS = GLOBAL.ACTIONS

local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS

-- The character select screen lines
GLOBAL.STRINGS.CHARACTER_TITLES.wayrra = "The Arctic Fox"
GLOBAL.STRINGS.CHARACTER_NAMES.wayrra = "Wayrra"
GLOBAL.STRINGS.CHARACTER_DESCRIPTIONS.wayrra = "*Has warm fur\n*Loves spiders... for dinner\n*Darkness? No, thank you"
GLOBAL.STRINGS.CHARACTER_QUOTES.wayrra = "\"C'mon it's not THAT cold!\""

-- Custom speech strings
GLOBAL.STRINGS.CHARACTERS.WAYRRA = require "speech_wayrra"

-- Custom items
STRINGS.NAMES.ORBSTAFF = "Fox Tribe Orb Staff"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ORBSTAFF = "Magical looking staff with orbs."

STRINGS.NAMES.SANITYORB = "Green Orb of Sanity"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SANITYORB = "It makes me feel good."

-- Let the game know character is male, female, or robot
table.insert(GLOBAL.CHARACTER_GENDERS.FEMALE, "wayrra")

-- Function to make beefalo hostile to character
local makeBeefaloHostile = function (prefab)
    if prefab.components.combat then
        local targetfn_orig = prefab.components.combat.targetfn
        local targetfn_new = function(inst)
            local target = nil
            -- First retarget normally
            if targetfn_orig then target = targetfn_orig(inst) end
            -- If no target found, target Wayrra
            if target == nil then
                target = GLOBAL.FindEntity(inst, GLOBAL.TUNING.BEEFALO_TARGET_DIST, function(guy)
                    return not guy:HasTag("beefalo") and
                            inst.components.combat:CanTarget(guy) and
                            not guy:HasTag("wall")
                            and guy.prefab == "wayrra"
                end)
            end
            return target
        end
        prefab.components.combat.targetfn = targetfn_new
    end
end
 
AddPrefabPostInit("beefalo", makeBeefaloHostile)
AddMinimapAtlas("images/map_icons/wayrra.xml")
AddMinimapAtlas("images/map_icons/orbstaff.xml")
AddModCharacter("wayrra")

